package org.processmining.lifecycleperformance.models.groovy

import org.processmining.lifecycleperformance.models.lifecycle.LifecycleModel
import org.processmining.lifecycleperformance.models.performance.PerformanceMeasure
import org.processmining.lifecycleperformance.models.performance.StateVisit
import org.processmining.lifecycleperformance.models.performance.TransitionExecution
import org.processmining.models.graphbased.directed.transitionsystem.State
import org.processmining.models.graphbased.directed.transitionsystem.Transition

class DSL extends Script{

	private LifecycleModel model = null;

	@Override
	public Object run() {
		// Nothing happening here.
	}

	/**
	 * Initializes the DSL script with the lifecycle model.
	 * @param model
	 */
	protected void initialize(LifecycleModel model) {
		this.model = model
	}

	def StateVisit[] stateVisits(String label) {
		State state = model.getNode(label);
		// Stored as an ArrayList<StateVisit> in the attribute map of the state
		return state.getAttributeMap().get(PerformanceMeasure.STATE_TIME_SPENT_COLLECTION)
	}

	def TransitionExecution[] transitionExecutions(String label) {
		// Get the first transition with this name.
		Transition transition = model.getEdges(label).iterator().next();
		// Stored as an ArrayList<StateVisit> in the attribute map of the transition
		return transition.getAttributeMap().get(PerformanceMeasure.TRANSITION_COLLECTION)
	}

	def long timeSpent(StateVisit sv) {
		return sv.getTimeSpent()
	}

	def Set<Long> timeSpent(StateVisit... stateVisits){
		Set<Long> timesSpent = new HashSet<Long>();
		for(StateVisit sv: stateVisits)
			timesSpent.add(timeSpent(sv))
		return timesSpent
	}

	def Set<Long> timeSpent(String label){
		StateVisit[] stateVisits = stateVisits(label)
		Set<Long> timesSpent = new HashSet<Long>();
		for(StateVisit sv: stateVisits)
			timesSpent.add(timeSpent(sv))
		return timesSpent
	}
}
