package org.processmining.lifecycleperformance.models.performance;

import org.processmining.lifecycleperformance.models.lifecycle.LifecycleModel;
import org.processmining.lifecycleperformance.parameters.LifecyclePerformanceParameters;

import com.google.common.collect.HashBasedTable;
import com.google.common.collect.Table;

public class PerformanceAnalysisResults {

	private LifecyclePerformanceParameters parameters;

	// Table of <String lifecycle model label, String instance label, LifeCycleModel instance lifecycle model>
	private Table<String, String, LifecycleModel> memory;

	public PerformanceAnalysisResults() {
		memory = HashBasedTable.create();
		parameters = new LifecyclePerformanceParameters();
	}

	public LifecyclePerformanceParameters getParameters() {
		return parameters;
	}

	public void setParameters(LifecyclePerformanceParameters parameters) {
		this.parameters = parameters;
	}

	public Table<String, String, LifecycleModel> getMemory() {
		return memory;
	}

	public void setMemory(Table<String, String, LifecycleModel> memory) {
		this.memory = memory;
	}

}
