package org.processmining.lifecycleperformance.models.performance;

import java.util.Objects;

public class PerformanceMetric {

	// FIELDS

	private String label;
	private String expression;
	private String format;

	// CONSTRUCTOR

	public PerformanceMetric(String label) {
		setLabel(label);
		setExpression("");
		setFormat("");
	}

	public PerformanceMetric(String label, String expression) {
		setLabel(label);
		setExpression(expression);
		setFormat("");
	}

	public PerformanceMetric(String label, String expression, String format) {
		setLabel(label);
		setExpression(expression);
		setFormat(format);
	}

	// GETTERS AND SETTERS

	public void setLabel(String label) {
		this.label = label;
	}

	public String getLabel() {
		return label;
	}

	public String getExpression() {
		return expression;
	}

	public void setExpression(String expression) {
		this.expression = expression;
	}

	public String getFormat() {
		return format;
	}

	public void setFormat(String format) {
		this.format = format;
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof PerformanceMetric))
			return false;

		PerformanceMetric metric = (PerformanceMetric) obj;

		if (!metric.label.equals(label))
			return false;

		if (!metric.expression.equals(expression))
			return false;

		if (!metric.format.equals(format))
			return false;

		return true;
	}

	@Override
	public int hashCode() {
		return Objects.hash(label, expression, format);
	}

	@Override
	public String toString() {
		return label + " (expression: '" + expression + "', format: '" + format + "')";
	}

}
