package org.processmining.lifecycleperformance.models.performance;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

public class StateVisit {

	// FIELDS

	private long timestampEntered;
	private long timestampExited;
	private Map<String, Object> properties;

	// CONSTRUCTORS

	public StateVisit() {
		setProperties(new HashMap<String, Object>());
	}

	public StateVisit(long in, long out) {
		this();
		setTimestampEntered(in);
		setTimestampExited(out);
	}

	// GETTERS AND SETTERS

	public long getTimestampEntered() {
		return timestampEntered;
	}

	public void setTimestampEntered(long timestampEntered) {
		this.timestampEntered = timestampEntered;
	}

	public long getTimestampExited() {
		return timestampExited;
	}

	public void setTimestampExited(long timestampExited) {
		this.timestampExited = timestampExited;
	}

	public Map<String, Object> getProperties() {
		return properties;
	}

	public void setProperties(Map<String, Object> properties) {
		this.properties = properties;
	}

	// METHODS

	public long getTimeSpent() {
		return timestampExited - timestampEntered;
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof StateVisit))
			return false;

		StateVisit sv = (StateVisit) obj;

		if (sv.timestampEntered != timestampEntered)
			return false;
		if (sv.timestampExited != timestampExited)
			return false;
		if (!sv.properties.equals(properties))
			return false;

		return true;
	}

	@Override
	public int hashCode() {
		return Objects.hash(timestampEntered, timestampExited, properties);
	}

	@Override
	public String toString() {
		return "in: " + timestampEntered + ", out: " + timestampExited + ", prop: " + properties.toString();
	}

}
